@echo off
setlocal EnableDelayedExpansion

echo Bolt 1
echo:

for %%c in (
	Bolt1.Net3.Debug
	Bolt1.Net3.Release
	Bolt1.Net4.Debug
	Bolt1.Net4.Release
) do (
	for %%u in (
		2017.4
		2018.4
		2019.1
		2019.2
		2019.3
		2020.1
	) do (
		set Configuration=%%c
		set UnityVersion=%%u
		set Project=!Configuration!.!UnityVersion!
		
		echo !Project!
		
		echo:
		
		echo Copying Project Template 
		xcopy /s /e /y ProjectTemplates\Bolt1 Projects\!Project!\
		
		echo:
		
		echo Symlinking Assemblies

		if exist Projects\!Project!\Assets\Ludiq\Assemblies rmdir Projects\!Project!\Assets\Ludiq\Assemblies
		mklink /j Projects\!Project!\Assets\Ludiq\Assemblies Assemblies\!Configuration!
		
		echo:
		
		echo Symlinking IconMaps
		
		for %%p in (
			Ludiq.Core
			Ludiq.Graphs
			Bolt.Core
			Bolt.Flow
			Bolt.State
		) do (
			set Plugin=%%p
			if exist Projects\!Project!\Assets\Ludiq\!Plugin!\IconMap\ rmdir Projects\!Project!\Assets\Ludiq\!Plugin!\IconMap
			mklink /j Projects\!Project!\Assets\Ludiq\!Plugin!\IconMap Package\!Plugin!\Editor\IconMap
		)

		echo:
		
		echo Symlinking Documentation
		
		if exist Projects\!Project!\Assets\Ludiq\Documentation\ rmdir Projects\!Project!\Assets\Ludiq\Documentation
		if exist Projects\!Project!\Assets\Ludiq\Bolt\Documentation\ rmdir Projects\!Project!\Assets\Ludiq\Bolt\Documentation
		mklink /j Projects\!Project!\Assets\Ludiq\Bolt\Documentation Package\Bolt\Documentation
		
		if exist Projects\!Project!\Assets\Ludiq\Ludiq.Core\DotNetDocumentation\ rmdir Projects\!Project!\Assets\Ludiq\Ludiq.Core\DotNetDocumentation
		mklink /j Projects\!Project!\Assets\Ludiq\Ludiq.Core\DotNetDocumentation Package\Ludiq.Core\DotNetDocumentation
		
		echo:
		echo:
	)
)


for %%i in (
	Bolt1.UAS
) do (
	echo %%i
	
	echo:
	
	echo Copying UAS Upload Project Template 
	xcopy /s /e /y ProjectTemplates\Bolt1.UAS Projects\%%i\
	
	echo:
	echo:
)

pause